# coding: utf-8

"""
    scibec

    scibec

    The version of the OpenAPI document: 1.14.0
    Contact: klaus.wakonig@psi.ch
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class AccessConfigWithRelations(BaseModel):
    """
    (tsType: AccessConfigWithRelations, schemaOptions: { includeRelations: true })
    """ # noqa: E501
    id: Optional[StrictStr] = None
    read_acl: Optional[List[StrictStr]] = Field(default=None, alias="readACL")
    write_acl: Optional[List[StrictStr]] = Field(default=None, alias="writeACL")
    owner: Optional[List[StrictStr]] = None
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    created_by: Optional[StrictStr] = Field(default=None, alias="createdBy")
    target_account: Optional[StrictStr] = Field(default=None, alias="targetAccount")
    beamline_id: StrictStr = Field(description="Beamline to which this config belongs.", alias="beamlineId")
    auth_enabled: StrictBool = Field(alias="authEnabled")
    active_accounts: Optional[List[StrictStr]] = Field(default=None, alias="activeAccounts")
    use_passwords: StrictBool = Field(alias="usePasswords")
    beamline: Optional[BeamlineWithRelations] = None
    functional_accounts: Optional[List[FunctionalAccountWithRelations]] = Field(default=None, alias="functionalAccounts")
    __properties: ClassVar[List[str]] = ["id", "readACL", "writeACL", "owner", "createdAt", "createdBy", "targetAccount", "beamlineId", "authEnabled", "activeAccounts", "usePasswords", "beamline", "functionalAccounts"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AccessConfigWithRelations from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of beamline
        if self.beamline:
            _dict['beamline'] = self.beamline.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in functional_accounts (list)
        _items = []
        if self.functional_accounts:
            for _item in self.functional_accounts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['functionalAccounts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of AccessConfigWithRelations from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "readACL": obj.get("readACL"),
            "writeACL": obj.get("writeACL"),
            "owner": obj.get("owner"),
            "createdAt": obj.get("createdAt"),
            "createdBy": obj.get("createdBy"),
            "targetAccount": obj.get("targetAccount"),
            "beamlineId": obj.get("beamlineId"),
            "authEnabled": obj.get("authEnabled"),
            "activeAccounts": obj.get("activeAccounts"),
            "usePasswords": obj.get("usePasswords"),
            "beamline": BeamlineWithRelations.from_dict(obj.get("beamline")) if obj.get("beamline") is not None else None,
            "functionalAccounts": [FunctionalAccountWithRelations.from_dict(_item) for _item in obj.get("functionalAccounts")] if obj.get("functionalAccounts") is not None else None
        })
        return _obj

from py_scibec_openapi_client.models.beamline_with_relations import BeamlineWithRelations
from py_scibec_openapi_client.models.functional_account_with_relations import FunctionalAccountWithRelations
# TODO: Rewrite to not use raise_errors
AccessConfigWithRelations.model_rebuild(raise_errors=False)

