# coding: utf-8

"""
    scibec

    scibec

    The version of the OpenAPI document: 1.14.0
    Contact: klaus.wakonig@psi.ch
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class SessionWithRelations(BaseModel):
    """
    (tsType: SessionWithRelations, schemaOptions: { includeRelations: true })
    """ # noqa: E501
    id: Optional[StrictStr] = None
    read_acl: Optional[List[StrictStr]] = Field(default=None, alias="readACL")
    write_acl: Optional[List[StrictStr]] = Field(default=None, alias="writeACL")
    owner: Optional[List[StrictStr]] = None
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    created_by: Optional[StrictStr] = Field(default=None, alias="createdBy")
    name: StrictStr
    experiment_id: Optional[StrictStr] = Field(default=None, description="Session to which this device belongs.", alias="experimentId")
    session_config: Optional[Dict[str, Any]] = Field(default=None, alias="sessionConfig")
    experiment: Optional[ExperimentWithRelations] = None
    scans: Optional[List[ScanWithRelations]] = None
    devices: Optional[List[DeviceWithRelations]] = None
    __properties: ClassVar[List[str]] = ["id", "readACL", "writeACL", "owner", "createdAt", "createdBy", "name", "experimentId", "sessionConfig", "experiment", "scans", "devices"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of SessionWithRelations from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of experiment
        if self.experiment:
            _dict['experiment'] = self.experiment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in scans (list)
        _items = []
        if self.scans:
            for _item in self.scans:
                if _item:
                    _items.append(_item.to_dict())
            _dict['scans'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in devices (list)
        _items = []
        if self.devices:
            for _item in self.devices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['devices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of SessionWithRelations from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "readACL": obj.get("readACL"),
            "writeACL": obj.get("writeACL"),
            "owner": obj.get("owner"),
            "createdAt": obj.get("createdAt"),
            "createdBy": obj.get("createdBy"),
            "name": obj.get("name"),
            "experimentId": obj.get("experimentId"),
            "sessionConfig": obj.get("sessionConfig"),
            "experiment": ExperimentWithRelations.from_dict(obj.get("experiment")) if obj.get("experiment") is not None else None,
            "scans": [ScanWithRelations.from_dict(_item) for _item in obj.get("scans")] if obj.get("scans") is not None else None,
            "devices": [DeviceWithRelations.from_dict(_item) for _item in obj.get("devices")] if obj.get("devices") is not None else None
        })
        return _obj

from py_scibec_openapi_client.models.device_with_relations import DeviceWithRelations
from py_scibec_openapi_client.models.experiment_with_relations import ExperimentWithRelations
from py_scibec_openapi_client.models.scan_with_relations import ScanWithRelations
# TODO: Rewrite to not use raise_errors
SessionWithRelations.model_rebuild(raise_errors=False)

